<?php

function _pluginMain($prmQuery) {
	$queryData = array();
	parse_str($prmQuery, $queryData);

	if ($queryData['channel_id'] !='') {
		$items = _pluginCreateChannelItems($queryData['channel_id']);
		return $items;
	}elseif ($queryData['category_url'] !='') {
		$items = _pluginCreateCategoryItems($queryData['category_url'], $queryData['page']);
		return $items;
	}elseif ($queryData['ctx'] !='') {
		$items = _pluginCreateVideoItems($queryData['ctx']);
                return $items;
	}else {
		$items = _pluginCreateMenu();
		return $items;
	}
}

function _pluginSearch($prmQuery) {
	preg_match('/and dc:title contains "(.*?)"/', $prmQuery, $searchstring);
	if ( isset($searchstring[1]) ) {
		$url = 'http://www.rtve.es/alacarta/search.html?q=' . urlencode($searchstring[1]);
		$items = _pluginCreateCategoryItems($url);
		return $items;
	} else {
		return null;
	}
}

function _pluginCreateMenu() {
	$categories = array(
				array(
					'Name' => 'Favoritos',
					'ID' => 'favoritos',
                                        'Image' => 'http://i52.tinypic.com/x0xm2s.jpg'
                                ), 
				array(
					'Name' => 'La 1',
					'ID' => 'la1',
					'Image' => 'http://i55.tinypic.com/15x3fgp.png'
				),
				array(
					'Name' => 'La 2',
					'ID' => 'la2',
					'Image' => 'http://i54.tinypic.com/29vxcsi.png'
				),
				array(
					'Name' => '24 horas',
					'ID' => '24-horas',
					'Image' => 'http://i54.tinypic.com/15yw0zp.png'
				),
				array(
					'Name' => 'Teledeporte',
					'ID' => 'teledeporte',
					'Image' => 'http://i56.tinypic.com/70e5qa.png'
				),
				array(
					'Name' => 'Clan',
					'ID' => 'clan',
					'Image' => 'http://i54.tinypic.com/rvy15h.png'
				),
                                array(
                                       'Name' => 'Todo TVE',
                                       'ID' => 'tve',
                                       'Image' => 'http://i56.tinypic.com/ips6zp.jpg' 
                                )
	);

	foreach($categories as $row) {
		$data = array(
				'channel_id' => $row['ID']
		);
		$retMediaItems[] = array (
						'id'		=> 'umsp://plugins/rtve?' . http_build_query($data, 'pluginvar_'),
						'dc:title'	=> html_entity_decode($row['Name'],0,"UTF-8"),
						'upnp:album_art'=>  $row['Image'],
						'upnp:class'	=> 'object.container',
		);
	}

	return $retMediaItems;
}

function _pluginCreateChannelItems($canal) {

$categories = array();

			     switch ($canal) {
                               case 'favoritos':
                                   $path = _LeerConfig();
                                   $xmlData = simplexml_load_file($path); 
                                   if($xmlData) {
                                   $programas = $xmlData->programa;
                                   foreach ($programas as $programa) {
                                    $cover = strval($programa->caratula);
                                    $data = array( 'ctx' => $programa->id ); 
                                    $dataString = http_build_query($data, 'pluginvar_');
                                      $retMediaItems[] = array (
                                         'id' => 'umsp://plugins/tvealacarta?' . $dataString,
                                         'dc:title' => html_entity_decode($programa->nombre,0,"UTF-8"),
                                         'upnp:album_art'=>  $cover,
                                         'upnp:class' => 'object.container',
                                         'protocolInfo' => '*:*:*:*'
                                         );
                                         }
                                     return $retMediaItems;} break 2;      
			       case 'clan':
			          $categories[] = array (	
					'Name' => 'Infantiles',
					'ID' => 'infantiles',
					'Image' => 'http://i54.tinypic.com/r8gidg.jpg'
				         );break;
                               case '24-horas':
                                  $categories[] = array (
                                        'Name' => 'Informativos',
                                        'ID' => 'informativos',
                                        'Image' => 'http://i56.tinypic.com/29yqiau.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Documentales',
                                        'ID' => 'documentales',
                                        'Image' => 'http://i56.tinypic.com/2vchqir.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Cultura',
                                        'ID' => 'cultura',
                                        'Image' => 'http://i51.tinypic.com/feqk54.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Ciencia y Tecnologia',
                                        'ID' => 'ciencia-y-tecnologia',
                                        'Image' => 'http://i52.tinypic.com/6s8ht3.jpg'
                                        );break;
                               case 'teledeporte':
			                 $categories[] = array (	
					     'Name' => 'Deportes',
					     'ID' => 'deportes',
					     'Image' => 'http://i55.tinypic.com/2cfcufk.jpg'
				        );break;
                               case 'la1':
                                  $categories[] = array (
                                        'Name' => 'Series',
                                        'ID' => 'series',
                                        'Image' => 'http://i51.tinypic.com/2rcpbwl.jpg'
                                 );
                                  $categories[] = array (
                                        'Name' => 'Informativos',
                                        'ID' => 'informativos',
                                        'Image' => 'http://i56.tinypic.com/29yqiau.jpg'
                                 );                                                                                                                                                                                                 
                                  $categories[] = array (
                                        'Name' => 'Documentales',
                                        'ID' => 'documentales',
                                        'Image' => 'http://i56.tinypic.com/2vchqir.jpg'
                                 );
                                  $categories[] = array (
                                        'Name' => 'Infantiles',
                                        'ID' => 'infantiles',
                                        'Image' => 'http://i54.tinypic.com/r8gidg.jpg'
                                 );
                                  $categories[] = array (
                                        'Name' => 'Deportes',
                                        'ID' => 'deportes',
                                        'Image' => 'http://i55.tinypic.com/2cfcufk.jpg'
                                 );
                                   $categories[] = array (
                                        'Name' => 'Archivo',
                                        'ID' => 'archivo',
                                        'Image' => 'http://i55.tinypic.com/9atzc3.jpg'
                                 );     
                                   $categories[] = array (
                                        'Name' => 'Magacin',
                                        'ID' => 'magacin',
                                        'Image' => 'http://i56.tinypic.com/1irb.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Cine',
                                        'ID' => 'cine',
                                        'Image' => 'http://i55.tinypic.com/2r58dqg.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Concursos',
                                        'ID' => 'concursos',
                                        'Image' => 'http://i56.tinypic.com/2eowrdg.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Viajes',
                                        'ID' => 'viajes',
                                        'Image' => 'http://i56.tinypic.com/2usbx37.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Educacion',
                                        'ID' => 'educacion',
                                        'Image' => 'http://i55.tinypic.com/9ifq5c.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Humor',
                                        'ID' => 'humor',
                                        'Image' => 'http://i53.tinypic.com/vrgeo3.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Musica',
                                        'ID' => 'musica',
                                        'Image' => 'http://i53.tinypic.com/208judc.jpg'
                                        );
			           $categories[] = array (	
					 'Name' => 'Otros Programas',
					 'ID' => 'otros-programas',
					 'Image' => 'http://i52.tinypic.com/2087m8y.jpg'
				 ); break; 
                               case 'la2' || 'tve':
                                  $categories[] = array (
                                        'Name' => 'Series',
                                        'ID' => 'series',
                                        'Image' => 'http://i51.tinypic.com/2rcpbwl.jpg'
                                 );
                                  $categories[] = array (
                                        'Name' => 'Informativos',
                                        'ID' => 'informativos',
                                        'Image' => 'http://i56.tinypic.com/29yqiau.jpg'
                                 );                                                                                                                                                                                                 
                                  $categories[] = array (
                                        'Name' => 'Documentales',
                                        'ID' => 'documentales',
                                        'Image' => 'http://i56.tinypic.com/2vchqir.jpg'
                                 );
                                  $categories[] = array (
                                        'Name' => 'Infantiles',
                                        'ID' => 'infantiles',
                                        'Image' => 'http://i54.tinypic.com/r8gidg.jpg'
                                 );
                                  $categories[] = array (
                                        'Name' => 'Deportes',
                                        'ID' => 'deportes',
                                        'Image' => 'http://i55.tinypic.com/2cfcufk.jpg'
                                 );
                                   $categories[] = array (
                                        'Name' => 'Archivo',
                                        'ID' => 'archivo',
                                        'Image' => 'http://i55.tinypic.com/9atzc3.jpg'
                                 );      
                                  $categories[] = array (
                                        'Name' => 'Ciencia y Tecnologia',
                                        'ID' => 'ciencia-y-tecnologia',
                                        'Image' => 'http://i52.tinypic.com/6s8ht3.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Cultura',
                                        'ID' => 'cultura',
                                        'Image' => 'http://i51.tinypic.com/feqk54.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Magacin',
                                        'ID' => 'magacin',
                                        'Image' => 'http://i56.tinypic.com/1irb.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Cine',
                                        'ID' => 'cine',
                                        'Image' => 'http://i55.tinypic.com/2r58dqg.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Concursos',
                                        'ID' => 'concursos',
                                        'Image' => 'http://i56.tinypic.com/2eowrdg.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Viajes',
                                        'ID' => 'viajes',
                                        'Image' => 'http://i56.tinypic.com/2usbx37.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Educacion',
                                        'ID' => 'educacion',
                                        'Image' => 'http://i55.tinypic.com/9ifq5c.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Religiosos',
                                        'ID' => 'religiosos',
                                        'Image' => 'http://i56.tinypic.com/vmx4kx.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Humor',
                                        'ID' => 'humor',
                                        'Image' => 'http://i53.tinypic.com/vrgeo3.jpg'
                                        );
                                  $categories[] = array (
                                        'Name' => 'Musica',
                                        'ID' => 'musica',
                                        'Image' => 'http://i53.tinypic.com/208judc.jpg'
                                        );
			          $categories[] = array (	
					'Name' => 'Otros Programas',
					'ID' => 'otros-programas',
					'Image' => 'http://i52.tinypic.com/2087m8y.jpg'
				        );    break;                              
        }
  
	foreach ($categories as $row) {
		$url = 'http://www.rtve.es/alacarta/programas/' . $canal . '/' . $row['ID'];

		$data = array(
				'category_url' => $url,'page' => 1
                             );

		$retMediaItems[] = array (
						'id'		=> 'umsp://plugins/rtve?' . http_build_query($data,'pluginvar_','&amp;'),
						'dc:title'	=> html_entity_decode($row['Name'],0,"UTF-8"),
						'upnp:album_art'=>  $row['Image'],
						'upnp:class'	=> 'object.container'
		);
	}
	return $retMediaItems;
}


function _pluginCreateCategoryItems($url,$page) {

        $complete_url = $url . '/' . $page . '/?pageSize=40&order=1&criteria=asc&emissionFilter=all';
	$html = file_get_contents($complete_url);
	preg_match_all('/<span class="cerrar" id="close([0-9]*?)"><\/span>[\s\n\t]*<span class="titulo-tooltip"><a href="(.*?)" title="Ver programa seleccionado">(.*?)<\/a>/',$html,$todo);

      if( $page > 1 ) {

       $data = array(
         'category_url' => $url, 'page' => $page - 1
         );

         $retMediaItems[] = array (
                    'id'            => 'umsp://plugins/rtve?' . http_build_query($data,'pluginvar_','&amp;'),
                    'dc:title'	=> "Pgina Anterior",
                    'upnp:album_art'=> 'http://i52.tinypic.com/2mpiluo.png',
                    'upnp:class'	=> 'object.container'
                    );
                }


	for($i=0;$i<count($todo[0]);$i++) {
		$retMediaItems[] = array (
						'id'		=> 'umsp://plugins/rtve?ctx=' . html_entity_decode($todo[1][$i],0,"UTF-8"),
						'dc:title'	=> html_entity_decode($todo[3][$i],0,"UTF-8"),
						'upnp:class'	=> 'object.container'
		);
	}

        if( preg_match('/class="siguiente">[\s\n\t]*<a name="paginaIR" href=".*\/([0-9]*)\/\?/', $html, $next_page)) {

         if( $page < $next_page[1]) {  

             $data = array(
             'category_url' => $url, 'page' => $page + 1
             );

             $retMediaItems[] = array (
                        'id'            => 'umsp://plugins/rtve?' . http_build_query($data,'pluginvar_','&amp;'),
                        'dc:title'	=> "Pgina Siguiente",
                        'upnp:album_art'=> 'http://i54.tinypic.com/91mjki.png', 
                        'upnp:class'	=> 'object.container'
                         );
                }
          }

	return $retMediaItems;
}

function _pluginCreateVideoItems($ctx) {
	$url = "http://www.rtve.es/alacarta/interno/contenttable.shtml?pbq=1&modl=TOC&locale=es&pageSize=100&ctx=".$ctx;
	$html = file_get_contents($url);
	preg_match_all('/titulo-tooltip...........(.*)".*title="(.*?)">/',$html,$todo);

	for ($z = 0; $z < sizeof($todo[1]); $z++) {
		$retMediaItems[] = array (
						'id'		=> 'Video' . $z,
						'parentID'	=> 'umsp://plugins/rtve',
						'dc:title'	=> $todo["2"][$z],
						'upnp:class'	=> 'object.item.videoitem',
						'res'		=> 'http://127.0.0.1/umsp/plugins/proxy_pydown.php?v=http://www.rtve.es'.$todo["1"][$z],
						'protocolInfo'	=> '*:*:*:*',
		                              );
	}
	return $retMediaItems;
}

function _LeerConfig() {
      $path=null; 
      if (file_exists('/conf/config')) {
      $config = file_get_contents('/conf/config');
      if(preg_match('/RTVE_FAVORITOS=\'(.+)\'/', $config, $config_result)) {
      $path = $config_result[1];
       }
     }   
   return $path;
  }
?>
